Subject: bug#20739: 25.0.50; Dired switches have no effect when explicit list of files provided

From: Eli Zaretskii <[email-masked]>
Date: Sun, 07 Jun 2015 22:09:31 +0300

> Date: Sun, 7 Jun 2015 10:34:18 -0700 (PDT)
> From: Drew Adams <[email-masked]>
> Cc: [email-masked]
> 
> > > > I've found no switches that are ignored as result of this
> > > > implementation, except those that control the order of the
> > > > files in the listing, so that's what I stated in the doc string.  
> > > > I think this makes the actual behavior clear enough.
> > >
> > > It is not about the order.  `r' works, for example - it reverses
> > > the order.
> > 
> > No, it doesn't.  The order is always the same as in the list you
> > pass to 'dired'.
> 
> That's not what I see.
> 
> (dired ("foo" "/path/to/bbbbb" "/path/to/foo.el" "/path/to/bar.el")
>        "-alFr")
> 
> shows the files in Dired in the reverse order: bar.el, foo.el,
> bbbbb.

Not in my Emacs, built from the latest development sources.

> > > It's not about switches that control the order.  It's about
> > > switches that deal with directory (or directories) themselves,
> > > their entire contents, as opposed to switches that deal only
> > > with an individual entry to be listed or that (like `r') deal
> > > only with the set of entries without needing any knowledge of
> > > the directory.
> > 
> > Yes, and those are all the switches that control the order of
> > presenting the files in the listing.
> 
> I don't agree.  Unless you are interpreting "switches that control
> the order" as including any switch that affects the display.

I do.

> You say that -C, for instance, "controls the order".  At least
> here (I'm using Cygwin), -C lists the entries by columns.  It
> does not change/control the order.

It shows them in column-wise order.

> > "-C" is about the order; the others are meaningless when you specify
> > the files explicitly.
> 
> Whether -A, -a, and -B are meaningless is in the eye of the user.
> The point is that if you specify an explicit . or .., switch -A
> still lists those directories.

They are also shown without -A or -a.  Specifying any files lists them
regardless.

> Why do you think that what is controlled by the ls-lisp.el code
> has nothing to do with this bug report?

Because 'dired' the function is not defined in ls-lisp.el, and it
works even without ls-lisp.

> The bug is about certain Dired switches having no effect when
> DIRNAME is a cons, even though they could work (have the usual
> effect).

Exactly.  And they have or don't have effect regardless of ls-lisp.